export const colorLegend = (selection, props) => {
  
  const { 
    colorScale, 
    circleRadius,
    onClick,
    selectedCate
  } = props;
  
  const groups = selection.selectAll('.legend')
    .data(colorScale.domain());
  
  const groupsEnter = groups
    .enter().append('g')
      .attr('class', 'legend');
  
  groupsEnter
    .merge(groups)
      .attr('transform', (d, i) =>
        `translate(0, ${i * 22})`
      )
      .on('click', d => onClick(
        d === selectedCate
        ? null
        : d
      ))
      .attr('opacity', d =>
        (!selectedCate || d === selectedCate)
        ? 1
        : 0.2
      );
  
  groups.exit().remove();
  
  groupsEnter.append('circle')
    .merge(groups.select('circle'))
      .attr('r', circleRadius)
      .attr('fill', colorScale)
      .attr('stroke', '#6d6863');
  
  groupsEnter.append('text')
    .merge(groups.select('text'))
      .text(d => d)
      .attr('dy', '0.32em')
      .attr('x', circleRadius * 1.5);
}